package com.zhyc.module.base.service;

import com.zhyc.module.base.domain.BasSheep;
import com.zhyc.module.base.domain.DaSheepfold;

import java.util.List;

/**
 * 羊舍管理Service接口
 * 
 * @author wyt
 * @date 2025-07-11
 */
public interface IDaSheepfoldService 
{
    /**
     * 查询羊舍管理
     * 
     * @param id 羊舍管理主键
     * @return 羊舍管理
     */
    public DaSheepfold selectDaSheepfoldById(Long id);

    /**
     * 查询羊舍管理列表
     * 
     * @param daSheepfold 羊舍管理
     * @return 羊舍管理集合
     */
    public List<DaSheepfold> selectDaSheepfoldList(DaSheepfold daSheepfold);

    public List<DaSheepfold> selectDaSheepfoldSummaryList(DaSheepfold daSheepfold);

    /**
     * 新增羊舍管理
     * 
     * @param daSheepfold 羊舍管理
     * @return 结果
     */
    public int insertDaSheepfold(DaSheepfold daSheepfold);

    /**
     * 修改羊舍管理
     * 
     * @param daSheepfold 羊舍管理
     * @return 结果
     */
    public int updateDaSheepfold(DaSheepfold daSheepfold);

    /**
     * 批量删除羊舍管理
     * 
     * @param ids 需要删除的羊舍管理主键集合
     * @return 结果
     */
    public int deleteDaSheepfoldByIds(Long[] ids);

    /**
     * 删除羊舍管理信息
     * 
     * @param id 羊舍管理主键
     * @return 结果
     */
    public int deleteDaSheepfoldById(Long id);

    /**
     * 检查羊舍编号是否已存在
     *
     * @param ranchId 羊舍所属牧场ID
     * @param sheepfoldTypeId 羊舍类型ID
     * @param sheepfoldNo 羊舍编号
     * @return 是否已存在
     */
    boolean checkSheepfoldNoExist(Long ranchId, Long sheepfoldTypeId, String sheepfoldNo);

//    根据羊舍id获取该羊舍的羊
    List<BasSheep> sheepListById(String id);


    /** 新增：根据组合条件删除羊圈记录 */
    boolean deleteSheepfoldByCondition(DaSheepfold sheepfold);
}
